# Class VulkanDescriptorPoolCreateInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanDescriptorPoolCreateInfo

All Implemented Interfaces:
  `VulkanDescriptorPoolCreateInfoType`

public final class VulkanDescriptorPoolCreateInfo extends Object implements VulkanDescriptorPoolCreateInfoType

See Also:
  - "VkDescriptorPoolCreateInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanDescriptorPoolCreateInfo.Builder`
  Builds instances of type `VulkanDescriptorPoolCreateInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanDescriptorPoolCreateInfo.Builder`
  `builder()`
  Creates a builder for `VulkanDescriptorPoolCreateInfo`.
  `static VulkanDescriptorPoolCreateInfo`
  `copyOf(VulkanDescriptorPoolCreateInfoType instance)`
  Creates an immutable copy of a `VulkanDescriptorPoolCreateInfoType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanDescriptorPoolCreateInfo` that have equal attribute values.
  `Set<VulkanDescriptorPoolCreateFlag>`
  `flags()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `flags`, `maxSets`, `poolSizes`.
  `int`
  `maxSets()`
  `static VulkanDescriptorPoolCreateInfo`
  `of(Iterable<VulkanDescriptorPoolCreateFlag> flags, int maxSets, Iterable<? extends VulkanDescriptorPoolSize> poolSizes)`
  Construct a new immutable `VulkanDescriptorPoolCreateInfo` instance.
  `static VulkanDescriptorPoolCreateInfo`
  `of(Set<VulkanDescriptorPoolCreateFlag> flags, int maxSets, List<VulkanDescriptorPoolSize> poolSizes)`
  Construct a new immutable `VulkanDescriptorPoolCreateInfo` instance.
  `List<VulkanDescriptorPoolSize>`
  `poolSizes()`
  `String`
  `toString()`
  Prints the immutable value `VulkanDescriptorPoolCreateInfo` with attribute values.
  `final VulkanDescriptorPoolCreateInfo`
  `withFlags(VulkanDescriptorPoolCreateFlag... elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanDescriptorPoolCreateInfo`
  `withFlags(Iterable<VulkanDescriptorPoolCreateFlag> elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanDescriptorPoolCreateInfo`
  `withMaxSets(int value)`
  Copy the current immutable object by setting a value for the `maxSets` attribute.
  `final VulkanDescriptorPoolCreateInfo`
  `withPoolSizes(VulkanDescriptorPoolSize... elements)`
  Copy the current immutable object with elements that replace the content of `poolSizes`.
  `final VulkanDescriptorPoolCreateInfo`
  `withPoolSizes(Iterable<? extends VulkanDescriptorPoolSize> elements)`
  Copy the current immutable object with elements that replace the content of `poolSizes`.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### flags

    public Set<VulkanDescriptorPoolCreateFlag> flags()
    Specified by:
      `flags` in interface `VulkanDescriptorPoolCreateInfoType`
    Returns:
      The flags specifying certain supported operations on the pool.

  - ### maxSets

    public int maxSets()
    Specified by:
      `maxSets` in interface `VulkanDescriptorPoolCreateInfoType`
    Returns:
      The maximum number of descriptor sets that can be allocated from the pool.

  - ### poolSizes

    public List<VulkanDescriptorPoolSize> poolSizes()
    Specified by:
      `poolSizes` in interface `VulkanDescriptorPoolCreateInfoType`
    Returns:
      An array of structures each containing a descriptor type and number of descriptors of that type to be allocated in the pool.

  - ### withFlags

    public final VulkanDescriptorPoolCreateInfo withFlags(VulkanDescriptorPoolCreateFlag... elements)
    Copy the current immutable object with elements that replace the content of `flags`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanDescriptorPoolCreateInfo withFlags(Iterable<VulkanDescriptorPoolCreateFlag> elements)
    Copy the current immutable object with elements that replace the content of `flags`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of flags elements to set
    Returns:
      A modified copy of `this` object

  - ### withMaxSets

    public final VulkanDescriptorPoolCreateInfo withMaxSets(int value)
    Copy the current immutable object by setting a value for the `maxSets` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for maxSets
    Returns:
      A modified copy of the `this` object

  - ### withPoolSizes

    public final VulkanDescriptorPoolCreateInfo withPoolSizes(VulkanDescriptorPoolSize... elements)
    Copy the current immutable object with elements that replace the content of `poolSizes`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withPoolSizes

    public final VulkanDescriptorPoolCreateInfo withPoolSizes(Iterable<? extends VulkanDescriptorPoolSize> elements)
    Copy the current immutable object with elements that replace the content of `poolSizes`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of poolSizes elements to set
    Returns:
      A modified copy of `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanDescriptorPoolCreateInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `flags`, `maxSets`, `poolSizes`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanDescriptorPoolCreateInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanDescriptorPoolCreateInfo of(Set<VulkanDescriptorPoolCreateFlag> flags, int maxSets, List<VulkanDescriptorPoolSize> poolSizes)
    Construct a new immutable `VulkanDescriptorPoolCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `maxSets` - The value for the `maxSets` attribute
      `poolSizes` - The value for the `poolSizes` attribute
    Returns:
      An immutable VulkanDescriptorPoolCreateInfo instance

  - ### of

    public static VulkanDescriptorPoolCreateInfo of(Iterable<VulkanDescriptorPoolCreateFlag> flags, int maxSets, Iterable<? extends VulkanDescriptorPoolSize> poolSizes)
    Construct a new immutable `VulkanDescriptorPoolCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `maxSets` - The value for the `maxSets` attribute
      `poolSizes` - The value for the `poolSizes` attribute
    Returns:
      An immutable VulkanDescriptorPoolCreateInfo instance

  - ### copyOf

    public static VulkanDescriptorPoolCreateInfo copyOf(VulkanDescriptorPoolCreateInfoType instance)
    Creates an immutable copy of a `VulkanDescriptorPoolCreateInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanDescriptorPoolCreateInfo instance

  - ### builder

    public static VulkanDescriptorPoolCreateInfo.Builder builder()
    Creates a builder for `VulkanDescriptorPoolCreateInfo`.

         VulkanDescriptorPoolCreateInfo.builder()
            .addFlags|addAllFlags(com.io7m.jcoronado.api.VulkanDescriptorPoolCreateFlag) // flags elements
            .setMaxSets(int) // required maxSets
            .addPoolSizes|addAllPoolSizes(VulkanDescriptorPoolSize) // poolSizes elements
            .build();

    Returns:
      A new VulkanDescriptorPoolCreateInfo builder